/**
 * 
 */
package ca.uqam.info.latece.sboa.inter.algorithms;

import no.uib.cipr.matrix.Vector;

import org.semanticweb.owl.align.Alignment;

import org.semanticweb.owl.model.OWLOntology;

import ca.uqam.info.latece.sboa.inter.ograph.OntologyGraph;
import ca.uqam.info.latece.sboa.inter.amatrix.AdjacencyMatrix;

/**
 * @author J.F. Djoufak
 *
 */
public interface StructureBasedAlignment {
	
	public void buildOGraph(OWLOntology onto1, OWLOntology onto2);
	public void buildMGraph(String distanceClass, String methodName);
	
	public void prepareToCompute();
	
	public Vector computeCBSimilarity(OntologyGraph mGraph, AdjacencyMatrix mMatrix, 
			Vector initVect);
	public Vector computeFBSimilarity(OntologyGraph mGraph, AdjacencyMatrix mMatrix, 
			Vector initVect);
	
	public Alignment extractResults(OntologyGraph mGraph, Vector simVect, int[] indVect, int sz);
	
	public void viewMemoryUsage(String mess);
}
