/**
 * 
 */
package ca.uqam.info.latece.sboa.inter.encodings;

import java.util.ArrayList;
import java.util.Hashtable;

import org.semanticweb.owl.model.OWLEntity;
import org.semanticweb.owl.model.OWLOntology;

import ca.uqam.info.latece.sboa.inter.ograph.Edge;
import ca.uqam.info.latece.sboa.inter.ograph.Vertice;
import ca.uqam.info.latece.sboa.inter.ograph.OntologyGraph;

import org.semanticweb.owl.impl.model.OWLClassImpl;
import org.semanticweb.owl.impl.model.OWLIndividualImpl;
import org.semanticweb.owl.impl.model.OWLDataPropertyImpl;
import org.semanticweb.owl.impl.model.OWLDataAllRestrictionImpl;
import org.semanticweb.owl.impl.model.OWLObjectAllRestrictionImpl;
import org.semanticweb.owl.impl.model.OWLDataCardinalityRestrictionImpl;
import org.semanticweb.owl.impl.model.OWLObjectCardinalityRestrictionImpl;

/**
 * @author J.F. Djoufak
 *
 */
public interface OLAOntologyGraph extends Extraction {

	public OntologyGraph build(OWLOntology onto);
	
	public void initGraphConstruction();
	
	public void buildEntitiesSets(OWLOntology onto);
	
	public void addVertice(ArrayList<Vertice> result, Hashtable<String, Integer> ht, 
			String cat, String lab, String comm, String ann, OWLEntity e1, OWLEntity e2, String key);
	
	public ArrayList<Vertice> buildVerticesFromClasses(OWLOntology onto);
	
	public ArrayList<Vertice> buildPropertyVerticesFromClass(
			OWLClassImpl owlC, OWLOntology onto);
	
	public ArrayList<Vertice>buildVerticesFromObjectCardinalityRestriction(
			OWLObjectCardinalityRestrictionImpl ocr, OWLOntology onto);
	
	public ArrayList<Vertice>buildVerticesFromDataCardinalityRestriction(
			OWLDataCardinalityRestrictionImpl dcr, OWLOntology onto);
	
	public ArrayList<Vertice>buildVerticesFromObjectAllRestriction(
			OWLObjectAllRestrictionImpl oar, OWLOntology onto);
	
	public ArrayList<Vertice>buildVerticesFromDataAllRestriction(
			OWLDataAllRestrictionImpl dar, OWLOntology onto);
	
	public ArrayList<Vertice> buildCardinalityVertice(String token);
	
	public ArrayList<Vertice> buildVerticesFromDatatypes();
	
	public ArrayList<Vertice> buildVerticesFromDataProperties(OWLOntology onto);
	
	public ArrayList<Vertice> buildVerticesFromDataPropertyRange(OWLDataPropertyImpl opi, 
			OWLOntology onto);
	
	public ArrayList<Vertice> buildVerticesFromObjectProperties(OWLOntology onto);
	
	public ArrayList<Vertice> buildVerticesFromIndividuals(OWLOntology onto);
	
	public ArrayList<Vertice> buildVerticesFromDataPropertyInstances(OWLIndividualImpl ind, 
			OWLOntology onto);
	
	public ArrayList<Vertice> buildVerticesFromObjectPropertyInstances(
			OWLIndividualImpl ind, OWLOntology onto);
	
	public void addEdge(ArrayList<Edge> result, String lab, int hd, int tl, double wgt);
	
	public ArrayList<Edge> encodeSubsumptionEdgesBetweenClasses(OWLOntology onto);
	
	public ArrayList<Edge> encodeSubsumptionEdgesBetweenProperties(OWLOntology onto);
	
	public ArrayList<Edge> encodeDomainEdgesBetweenDataPropertiessAndClasses(OWLOntology onto);
	
	public ArrayList<Edge> encodeDomainEdgesBetweenObjectPropertiessAndClasses(OWLOntology onto);
	
	public ArrayList<Edge> encodeAttributionEdgesBetweenClassesAndProperties(
			String cName, String pName);
	
	public ArrayList<Edge> encodeSubsumptionEdgesBetweenPropertiesAndRelations(
			String pName, String rName);
	
	public ArrayList<Edge> encodeRangeEdgesBetweenDataPropertiessAndDatatype(OWLOntology onto);
	
	public ArrayList<Edge> encodeAllEdgesBetweenPropertiesAndDatatypes(
			String pName, String dName);
	
	public ArrayList<Edge> encodeRangeEdgesBetweenObjectPropertiesAndClasses(OWLOntology onto);
	
	public ArrayList<Edge> encodeAllEdgesBetweenPropertiesAndClasses(
			String pName, String cName);
	
	public ArrayList<Edge> encodeInstantiationEdgesBetweenClassesAndObjects(OWLOntology onto);
	
	public ArrayList<Edge> encodeEdgesBetweenObjectsPropertyInstanceDataPropertiesAndDataTypes(
			OWLIndividualImpl ind, String iName, int iId, OWLOntology onto);
	
	public ArrayList<Edge> encodeEdgesBetweenObjectsPropertyInstancesAndObjectProperties(
			OWLIndividualImpl ind, String iName, int iId, OWLOntology onto);
	
	public ArrayList<Edge> encodeRestrictionEdgeBetweenPropertyAndCardinality(Vertice[] ver);
	
	public void updatePropertyInstanceName(Vertice[] verS);
	
	public OntologyGraph completeOntologyGraph(OntologyGraph og, Object[] vSet, boolean useLab);
	
	public int directVerticeInsertion(OntologyGraph og, String cat, String name);
	
	public void directEdgeInsertion(OntologyGraph og, String lab, int hd, int tl, double wgt);
	
	public void clearAll();
}
