/**
 * 
 */
package ca.uqam.info.latece.sboa.inter.ograph;

import java.io.PrintWriter;
import java.util.Hashtable;
import java.util.TreeSet;

import no.uib.cipr.matrix.Matrix;
import no.uib.cipr.matrix.Vector;

import ca.uqam.info.latece.sboa.inter.amatrix.AdjacencyMatrix;

/**
 * @author J.F. Djoufak
 *
 */
public interface OntologyGraph {
	
	public void init(String[] categories, String[] labels);
	
	public void insertVertice(Object ver);
	public void insertVertice(Object[] vSet);
	
	public void insertEdge(Object edg);
	public void insertEdge(Object[] eSet);
	
	public void upgradeVerticePool();
	
	public Pool getEdgePool();
	public Pool getVerticePool();
	
	public void StraightforwardBuild(Object[] vSet, Object[] eSet);
	public void ImprovedBuild(Object[] vSet, Object[] eSet, String thesaurus);
	
	public AdjacencyMatrix getLabelAdjacencyMatrix(String lab);
	public AdjacencyMatrix getCategoryAdjacencyMatrix(String cat1, String cat2);
	public Matrix createCategoryMatrix(String[] cat, int nbParts, int nOfLines, Hashtable<Integer, 
			Integer> IdToIndices);
	
	public int[] getCategoryMatrixVerticeIds(String[] cat, int nbParts, Hashtable<Integer,Integer> IdToIndices);
	
	public AdjacencyMatrix[] getLabelMatrices();
	public AdjacencyMatrix getCategoryMatrix();
	
	public Vector getInitialVector(int[] verIds, int sz);
	
	public void viewAll();
	public void clearAll();
	
	public void getResume();
	public String concactLabels(String lab);
	
	public String defaultName(Vertice ver, String[] repr, int[] lIds, int rSz, TreeSet<Integer> reach);
	public String[] buildRepresentatives(String[] lab);
	public void setRepresentatives(String[] cRep, String[] lRep);
	public void buildAllDefaultNames(String[] rootLab, String[] rEdgeLab,
			String[] remVer, String[] remEdg);
	
	
	public int[] getStaticWeightVertices(String[] cat, int sz);
	public int getNumberOfStaticWeightVertices();
	
	public void createGraphMLFile(String name, String fpath);
	public void initGraphMLFile(PrintWriter out, String name);
	public void insertVerticesInGraphMLFile(PrintWriter out);
	public void insertEdgesInGraphMLFile(PrintWriter out);
	public String getVerticeShape(String category);
	public void finalizeGraphMLFile(PrintWriter out);
}
